petsc-3.12.4 2020-02-04
Report Typos and Errors

# DMForestGetAdaptivityPurpose

Get whether the current DM is being adapted from its source (set with DMForestSetAdaptivityForest()) for the purpose of refinement (DM_ADAPT_REFINE), coarsening (DM_ADAPT_COARSEN), coarsening only the last level (DM_ADAPT_COARSEN_LAST) or undefined (DM_ADAPT_DETERMINE). This only matters for the purposes of reference counting: during DMDestroy(), cyclic references can be found between DMs only if the cyclic reference is due to a fine/coarse relationship (see DMSetFineDM()/DMSetCoarseDM()). If the purpose is not refinement or coarsening, and the user does not maintain a reference to the post-adaptation forest (i.e., the one created by DMForestTemplate()), then this can cause a memory leak. This method is used by subtypes of DMForest when automatically constructing mesh hierarchies.

### Synopsis

    #include "petscdmforest.h"
    #include "petscdm.h"
    #include "petscdmlabel.h"
    PetscErrorCode DMForestGetAdaptivityPurpose(DM dm, DMAdaptFlag *purpose)

Not collective

### Input Parameter

dm -the forest

### Output Parameter

purpose -the adaptivity purpose

### See Also

DMForestTemplate(), DMForestSetAdaptivityForest(), DMForestGetAdaptivityForest(), DMAdaptFlag

### Level

advanced

### Location

src/dm/impls/forest/forest.c
Index of all DMFOREST routines
Table of Contents for all manual pages
Index of all manual pages